"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLatestVersion = exports.getURL = void 0;
const node_fetch_1 = __importDefault(require("node-fetch"));
function getURL(org, repo, api) {
    let url = '';
    if (api === 'brew') {
        url = `https://formulae.brew.sh/api/formula/${repo}.json`;
    }
    else if (api === 'github') {
        url = `https://api.github.com/repos/${org}/${repo}/releases/latest`;
    }
    return url;
}
exports.getURL = getURL;
function getLatestVersion(org, repo, api) {
    return __awaiter(this, void 0, void 0, function* () {
        const url = getURL(org, repo, api);
        console.log('url', url);
        const response = yield node_fetch_1.default(url);
        const json = yield response.json();
        let latestVersion = '';
        if (api === 'brew') {
            latestVersion = json.versions.stable;
        }
        else if (api === 'github') {
            latestVersion = json.tag_name;
        }
        return latestVersion;
    });
}
exports.getLatestVersion = getLatestVersion;
//# sourceMappingURL=get-latest-version.js.map