"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = exports.showVersion = void 0;
const core = __importStar(require("@actions/core"));
const exec = __importStar(require("@actions/exec"));
const get_latest_version_1 = require("./get-latest-version");
const installer_1 = require("./installer");
const constants_1 = require("./constants");
const fs_1 = __importDefault(require("fs"));
const fs = fs_1.default.promises;
function showVersion(cmd, args) {
    return __awaiter(this, void 0, void 0, function* () {
        const actRcPath = '.actrc';
        const isActRcExist = fs_1.default.existsSync(actRcPath);
        if (!isActRcExist) {
            const actRC = `-P ubuntu-latest=node:12.6-buster-slim\n-P ubuntu-20.04=node:12.6-buster-slim\n-P ubuntu-18.04=node:12.6-buster-slim\n-P ubuntu-16.04=node:12.6-stretch-slim`;
            yield fs.writeFile(actRcPath, actRC);
        }
        const result = {
            exitcode: 0,
            output: ''
        };
        const options = {
            listeners: {
                stdout: (data) => {
                    result.output += data.toString();
                }
            }
        };
        result.exitcode = yield exec.exec(cmd, args, options);
        core.debug(`command: ${cmd} ${args}`);
        core.debug(`exit code: ${result.exitcode}`);
        core.debug(`stdout: ${result.output}`);
        if (!isActRcExist) {
            yield fs.unlink(actRcPath);
        }
        return result;
    });
}
exports.showVersion = showVersion;
function run(options) {
    return __awaiter(this, void 0, void 0, function* () {
        let toolVersion = '';
        if (options) {
            if (options.version) {
                toolVersion = options.version;
            }
        }
        let installVersion = '';
        let result = {
            exitcode: 0,
            output: ''
        };
        if (toolVersion === '' || toolVersion === 'latest') {
            installVersion = yield get_latest_version_1.getLatestVersion(constants_1.Tool.Org, constants_1.Tool.Repo, 'brew');
        }
        else {
            installVersion = toolVersion;
        }
        core.info(`${constants_1.Tool.Name} version: ${installVersion}`);
        yield installer_1.installer(installVersion);
        result = yield showVersion(constants_1.Tool.CmdName, [constants_1.Tool.CmdOptVersion]);
        return result;
    });
}
exports.run = run;
//# sourceMappingURL=main.js.map